/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.15 from the
 * contents of RingBuffer.xs. Do not edit this file, edit RingBuffer.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "RingBuffer.xs"
#ifdef __cplusplus
extern "C" {
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef WIN32
#include <time.h>
#else
#include <sys/time.h>
#endif

#include "ringbuffer.h"

#ifdef __cplusplus
}
#endif

/*
 *	kiped from Time::HiRes; only works for Win32 and POSIX
 */
#ifdef WIN32

typedef union {
    unsigned __int64	ft_i64;
    FILETIME		ft_val;
} FT_t;

/* Number of 100 nanosecond units from 1/1/1601 to 1/1/1970 */
#ifdef __GNUC__
#define Const64(x)	x##LL
#else
#define Const64(x)	x##i64
#endif
# define EPOCH_BIAS Const64(116444736000000000)
/*
 *	we don't give a damn about all the fancy drift and skew...
 *	just give us a reasonable hires timestamp
 */
double
_hires_time()
{
    FT_t ft;
    unsigned long tv_sec;
    unsigned long tv_usec;
    double retval;

	GetSystemTimeAsFileTime(&ft.ft_val);

    /* seconds since epoch */
    tv_sec = (long) ( (ft.ft_i64 - EPOCH_BIAS) / Const64(10000000) );

    /* microseconds remaining */
    tv_usec = (long)( (ft.ft_i64 / Const64(10)) % Const64(1000000) );

	retval = tv_sec + (tv_usec / 1000000.);
	return retval;
}
#else
double _hires_time() {
	struct timeval Tp;
	int status = gettimeofday (&Tp, NULL);
	double retval = -1.0;

	if (! status)
		retval = Tp.tv_sec + (Tp.tv_usec / 1000000.);
	return retval;
}
#endif

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 87 "RingBuffer.c"

XS(XS_Devel__RingBuffer__get_ring_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__get_ring_size)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::_get_ring_size(slots, slotsz, msgarea_size)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	slots = (int)SvIV(ST(0));
	int	slotsz = (int)SvIV(ST(1));
	int	msgarea_size = (int)SvIV(ST(2));
#line 86 "RingBuffer.xs"
    	int ringsz = sizeof(ring_header_t) +
    		(slots * (slotsz + sizeof(ring_slothdr_t))) +
    		msgarea_size;
		ST(0) = sv_2mortal(newSViv(ringsz));
		XSRETURN(1);
#line 108 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__get_total_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__get_total_size)
{
    dXSARGS;
    if (items != 5)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::_get_total_size(count, slots, slotsz, msgarea_size, global_size)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	count = (int)SvIV(ST(0));
	int	slots = (int)SvIV(ST(1));
	int	slotsz = (int)SvIV(ST(2));
	int	msgarea_size = (int)SvIV(ST(3));
	int	global_size = (int)SvIV(ST(4));
#line 105 "RingBuffer.xs"
    	int ringsz = sizeof(ring_header_t) +
    		(slots * (slotsz + sizeof(ring_slothdr_t))) +
    		msgarea_size;
    	int total = sizeof(ring_buffers_t) + global_size + count + (ringsz * count);
		ST(0) = sv_2mortal(newSViv(total));
		XSRETURN(1);
#line 137 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__get_rings_addr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__get_rings_addr)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::_get_rings_addr(addr, count, global_size)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	int	count = (int)SvIV(ST(1));
	int	global_size = (int)SvIV(ST(2));
#line 122 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        tmp += sizeof(ring_bufhdr_t) + count + global_size;
		ST(0) = sv_2mortal(newSVuv(tmp));
		XSRETURN(1);
#line 162 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__get_ring_addr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__get_ring_addr)
{
    dXSARGS;
    if (items != 5)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::_get_ring_addr(addr, ringnum, slots, slotsz, msgarea_size)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	UV	ringnum = (UV)SvUV(ST(1));
	int	slots = (int)SvIV(ST(2));
	int	slotsz = (int)SvIV(ST(3));
	int	msgarea_size = (int)SvIV(ST(4));
#line 139 "RingBuffer.xs"
        UV tmp = SvUV(addr);
    	UV ringsz = sizeof(ring_header_t) +
    		(slots * (slotsz + sizeof(ring_slothdr_t))) +
    		msgarea_size;
    	tmp += (ringsz * ringnum);

		ST(0) = sv_2mortal(newSVuv(tmp));
		XSRETURN(1);
#line 193 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__alloc_ring); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__alloc_ring)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::_alloc_ring(mapaddr, count)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	mapaddr = ST(0);
	int	count = (int)SvIV(ST(1));
#line 162 "RingBuffer.xs"
        IV tmp = SvIV(mapaddr);
		char * freemap = INT2PTR(caddr_t,tmp);
		int i = 0;

		for (; ((i < count) && (! *freemap)); i++, freemap++);
		if (i < count) {
			*freemap = 0;
			ST(0) = sv_2mortal(newSViv(i));
		}
		else
			ST(0) = &PL_sv_undef;
		XSRETURN(1);
#line 225 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__free_ring); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__free_ring)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::_free_ring(mapaddr, ringaddr, ringbufsz, ringnum)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	mapaddr = ST(0);
	SV *	ringaddr = ST(1);
	int	ringbufsz = (int)SvIV(ST(2));
	int	ringnum = (int)SvIV(ST(3));
#line 186 "RingBuffer.xs"
        UV tmp = SvUV(mapaddr);
		char * freemap = INT2PTR(caddr_t,tmp);
		ring_bufptr_t ring;

        tmp = SvUV(ringaddr);
        tmp += (ringnum * ringbufsz);
		ring = INT2PTR(ring_bufptr_t, tmp);

		freemap[ringnum] = 1;
		ring->hdr.pid = 0;
		ring->hdr.tid = 0;
		ring->hdr.currSlot = -1;
		ring->hdr.depth = 0;
		ST(0) = &PL_sv_yes;
		XSRETURN(1);
#line 262 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__find_ring); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__find_ring)
{
    dXSARGS;
    if (items != 5)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::_find_ring(ringaddr, ringbufsz, count, pid, tid)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ringaddr = ST(0);
	int	ringbufsz = (int)SvIV(ST(1));
	int	count = (int)SvIV(ST(2));
	int	pid = (int)SvIV(ST(3));
	int	tid = (int)SvIV(ST(4));
#line 214 "RingBuffer.xs"
        UV tmp = SvUV(ringaddr);
		ring_bufptr_t ring = INT2PTR(ring_bufptr_t,tmp);
		int i = 0;

		while ((i < count) &&
			((ring->hdr.pid != pid) || (ring->hdr.tid != tid))) {
			i++;
			tmp += ringbufsz;
			ring = INT2PTR(ring_bufptr_t,tmp);
		}
		ST(0) = (i < count) ? sv_2mortal(newSViv(i)) : &PL_sv_undef;
		XSRETURN(1);
#line 297 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__init_ring); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__init_ring)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_init_ring(addr, pid, tid, baseaddr)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	int	pid = (int)SvIV(ST(1));
	int	tid = (int)SvIV(ST(2));
	SV *	baseaddr = ST(3);
#line 240 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        UV basetmp = SvUV(baseaddr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        ringbuf_hdrptr_t ringbuf = INT2PTR(ringbuf_hdrptr_t, basetmp);
        UV slotsaddr = tmp + sizeof(ring_header_t) + ringbuf->msgarea_sz;
        int i;

        ring->hdr.pid = pid;
        ring->hdr.tid = tid;
        ring->hdr.currSlot = -1;
        ring->hdr.depth = 0;
        ring->hdr.trace = ringbuf->trace_on_create;
        ring->hdr.signal = ringbuf->stop_on_create;
        ring->hdr.baseoff = tmp - basetmp;
        ring->hdr.cmdready = 0;
        memset(&ring->hdr.command, ' ', 4);

        for (i = 0; i < STRACE_WATCH_CNT; i++)
        	ring->hdr.watches[i].inuse = 0;

		ST(0) = &PL_sv_yes;
		XSRETURN(1);
#line 341 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__get_slots_addr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__get_slots_addr)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_get_slots_addr(addr)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
#line 271 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        ringbuf_hdrptr_t ringbuf = INT2PTR(ringbuf_hdrptr_t, (tmp - ring->hdr.baseoff));
        UV slotsaddr = tmp + sizeof(ring_header_t) + ringbuf->msgarea_sz;
		ST(0) = sv_2mortal(newSVuv(slotsaddr));
		XSRETURN(1);
#line 366 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__get_header); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__get_header)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_get_header(addr)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
#line 286 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);

		EXTEND(SP, 4);
		PUSHs(sv_2mortal(newSViv(ring->hdr.pid)));
		PUSHs(sv_2mortal(newSViv(ring->hdr.tid)));
		PUSHs(sv_2mortal(newSViv(ring->hdr.currSlot)));
		PUSHs(sv_2mortal(newSViv(ring->hdr.depth)));
#line 393 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring_updateSlot); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring_updateSlot)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::updateSlot(addr, lineno)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	int	lineno = (int)SvIV(ST(1));
#line 303 "RingBuffer.xs"
        UV tmp;
        ring_bufptr_t ring;
        ringbuf_hdrptr_t ringbuf;
        UV slotsaddr;
        ring_slotptr_t slot;
        AV *self;
        if (SvROK(addr)) {
        	self = (AV *)(SvRV(addr));
        	tmp = SvUV(*(av_fetch(self, 2, 0)));
        }
        else {
	        tmp = SvUV(addr);
	    }
        ring = INT2PTR(ring_bufptr_t, tmp);

		if (!  ring->hdr.trace) {
			ST(0) = &PL_sv_yes;
		}
		else {
        	ringbuf = INT2PTR(ringbuf_hdrptr_t, (tmp - ring->hdr.baseoff));
        	slotsaddr = tmp + sizeof(ring_header_t) + ringbuf->msgarea_sz;
        	slot = NULL;

			if (ring->hdr.currSlot < 0) {
				ST(0) = &PL_sv_undef;
			}
			else {
        		slotsaddr += (ring->hdr.currSlot * (ringbuf->slot_sz + sizeof(ring_slothdr_t)));
	    	    slot = INT2PTR(ring_slotptr_t, slotsaddr);
				slot->hdr.linenumber = lineno;
				slot->hdr.timestamp = _hires_time();
				ST(0) = &PL_sv_yes;
			}
		}
		XSRETURN(1);
#line 448 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring_nextSlot); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring_nextSlot)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::nextSlot(addr, entry)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	SV *	entry = ST(1);
#line 352 "RingBuffer.xs"
        UV tmp;
        ring_bufptr_t ring;
        ringbuf_hdrptr_t ringbuf;
        UV slotsaddr;
        ring_slotptr_t slot = NULL;
        int currslot;
        int entrylen;
       	AV *self;
        if (SvROK(addr)) {
        	self = (AV *)(SvRV(addr));
        	tmp = SvUV(*(av_fetch(self, 2, 0)));
        }
        else {
	        tmp = SvUV(addr);
	    }
        ring = INT2PTR(ring_bufptr_t, tmp);
        ringbuf = INT2PTR(ringbuf_hdrptr_t, (tmp - ring->hdr.baseoff));
        slotsaddr = tmp + sizeof(ring_header_t) + ringbuf->msgarea_sz;
        currslot = ring->hdr.currSlot + 1;
        entrylen = SvCUR(entry);

        if (entrylen >= ringbuf->slot_sz)
        	entrylen = ringbuf->slot_sz - 1;
       	if (currslot >= 0)
        	ring->hdr.depth++;

		if (currslot >= ringbuf->slots)
	    	currslot = 0;

		ring->hdr.currSlot = currslot;

       	slotsaddr += (currslot * (ringbuf->slot_sz + sizeof(ring_slothdr_t)));
        slot = INT2PTR(ring_slotptr_t, slotsaddr);
		slot->hdr.linenumber = 0;
		slot->hdr.timestamp = _hires_time();
		memcpy(slot->subroutine, SvPV_nolen(entry), entrylen);
		slot->subroutine[entrylen] = '\0';

		ST(0) = sv_2mortal(newSViv(ring->hdr.depth));
		XSRETURN(1);
#line 508 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring_freeSlot); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring_freeSlot)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::freeSlot(addr)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
#line 406 "RingBuffer.xs"
        UV tmp;
        ring_bufptr_t ring;
        ringbuf_hdrptr_t ringbuf;
        UV slotsaddr;
        ring_slotptr_t slots = NULL;
        int currslot;
       	AV *self;
        if (SvROK(addr)) {
        	self = (AV *)(SvRV(addr));
        	tmp = SvUV(*(av_fetch(self, 2, 0)));
        }
        else {
	        tmp = SvUV(addr);
	    }
        ring = INT2PTR(ring_bufptr_t, tmp);
        ringbuf = INT2PTR(ringbuf_hdrptr_t, (tmp - ring->hdr.baseoff));
        slotsaddr = tmp + sizeof(ring_header_t) + ringbuf->msgarea_sz;
        currslot = ring->hdr.currSlot;
        ring->hdr.depth--;

        if (ring->hdr.depth < 0) {
        	printf("ring for %i underflow with slot %i\n", ring->hdr.tid, currslot);
        	ring->hdr.depth = 0;
        }
       	slotsaddr += (currslot * (ringbuf->slot_sz + sizeof(ring_slothdr_t)));
        slots = INT2PTR(ring_slotptr_t, slotsaddr);

		strcpy(slots->subroutine, "(Invalid slot due to prior wrap)");
		slots->hdr.linenumber = -1;
		slots->hdr.timestamp = 0.0;

		currslot--;
		if ((currslot < 0) && (ring->hdr.depth > 0))
			currslot = ringbuf->slots - 1;
		ring->hdr.currSlot = currslot;

		ST(0) = sv_2mortal(newSViv(ring->hdr.depth));
		XSRETURN(1);
#line 565 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__get_slot); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__get_slot)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_get_slot(addr, slotnum)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	int	slotnum = (int)SvIV(ST(1));
#line 460 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        ringbuf_hdrptr_t ringbuf = INT2PTR(ringbuf_hdrptr_t, (tmp - ring->hdr.baseoff));
        UV slotsaddr = tmp + sizeof(ring_header_t) + ringbuf->msgarea_sz +
        	(slotnum * (ringbuf->slot_sz + sizeof(ring_slothdr_t)));
        ring_slotptr_t slots = INT2PTR(ring_slotptr_t, slotsaddr);

		EXTEND(SP, 2);
		PUSHs(sv_2mortal(newSViv(slots->hdr.linenumber)));
		PUSHs(sv_2mortal(newSVnv(slots->hdr.timestamp)));
		PUSHs(sv_2mortal(newSVpv(slots->subroutine, strlen(slots->subroutine))));
#line 596 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring_getFlags); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring_getFlags)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::getFlags(addr)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
#line 480 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        ringbuf_hdrptr_t ringbuf = INT2PTR(ringbuf_hdrptr_t, (tmp - ring->hdr.baseoff));
		int retval = (ringbuf->single ? 1 : 0) | (ring->hdr.trace ? 2 : 0) | (ring->hdr.signal ? 4 : 0);
		ST(0) = sv_2mortal(newSViv(retval));
		XSRETURN(1);
#line 621 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__get_trace); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__get_trace)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_get_trace(addr)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
#line 492 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        ST(0) = sv_2mortal(newSViv(ring->hdr.trace));
		XSRETURN(1);
#line 644 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__set_trace); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__set_trace)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_set_trace(addr, val)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	int	val = (int)SvIV(ST(1));
#line 506 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        ST(0) = sv_2mortal(newSViv(ring->hdr.trace));
        ring->hdr.trace = val;
		XSRETURN(1);
#line 669 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__get_signal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__get_signal)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_get_signal(addr)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
#line 517 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        ST(0) = sv_2mortal(newSViv(ring->hdr.signal));
		XSRETURN(1);
#line 692 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__set_signal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__set_signal)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_set_signal(addr, val)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	int	val = (int)SvIV(ST(1));
#line 531 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        ST(0) = sv_2mortal(newSViv(ring->hdr.signal));
        ring->hdr.signal = val;
		XSRETURN(1);
#line 717 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__post_cmd_msg); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__post_cmd_msg)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_post_cmd_msg(addr, resp, msg, state)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	SV *	resp = ST(1);
	SV *	msg = ST(2);
	int	state = (int)SvIV(ST(3));
#line 548 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        ringbuf_hdrptr_t ringbuf = INT2PTR(ringbuf_hdrptr_t, (tmp - ring->hdr.baseoff));

		int resplen = SvCUR(resp);
		int msglen = SvCUR(msg);

		if (resplen > 4)
			resplen = 4;

		if (msglen > ringbuf->msgarea_sz)
			msglen = ringbuf->msgarea_sz;

		ring->hdr.msglen = msglen;

		memset(ring->hdr.command, '\0', 4);
		memset(ring->msgarea, '\0', ringbuf->msgarea_sz);
		memcpy(ring->hdr.command, SvPV_nolen(resp), resplen);
		memcpy(ring->msgarea, SvPV_nolen(msg), msglen);

		ring->hdr.cmdready = state;
		ST(0) = &PL_sv_yes;
		XSRETURN(1);
#line 762 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__check_for_cmd_msg); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__check_for_cmd_msg)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_check_for_cmd_msg(addr, state)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	int	state = (int)SvIV(ST(1));
#line 581 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
		int msglen = ring->hdr.msglen;
		char lclcmd[5];

		EXTEND(SP, 2);
		if (ring->hdr.cmdready != state) {
			PUSHs(&PL_sv_undef);
			PUSHs(&PL_sv_undef);
		}
		else {
			strncpy(lclcmd, ring->hdr.command, 4);
			lclcmd[4] = '\0';
			PUSHs(sv_2mortal(newSVpvn(lclcmd, strlen(lclcmd))));
			PUSHs(sv_2mortal(newSVpvn(ring->msgarea, ring->hdr.msglen)));
		}
#line 798 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__get_watch_expr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__get_watch_expr)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_get_watch_expr(addr, watch)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	int	watch = (int)SvIV(ST(1));
#line 607 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);

		ST(0) = &PL_sv_undef;

		if ((watch >= 0) && (watch < STRACE_WATCH_CNT) &&
			ring->hdr.watches[watch].inuse &&
			(!ring->hdr.watches[watch].resready)) {

			if (ring->hdr.watches[watch].inuse < 0)
				ring->hdr.watches[watch].inuse = 0;
			else
				ST(0) = sv_2mortal(newSVpv(ring->hdr.watches[watch].expr, ring->hdr.watches[watch].exprlength));
		}
		XSRETURN(1);
#line 833 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__set_watch_result); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__set_watch_result)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_set_watch_result(addr, watch, result, error)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	int	watch = (int)SvIV(ST(1));
	SV *	result = ST(2);
	SV *	error = ST(3);
#line 634 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        int len;

		ST(0) = &PL_sv_undef;
		if ((watch >= 0) && (watch < STRACE_WATCH_CNT)) {
			len = SvCUR(result);
			if (len > STRACE_WATCH_RESLEN)
				len = STRACE_WATCH_RESLEN;

			if (SvOK(error) && SvCUR(error)) {
				ring->hdr.watches[watch].reslength = -len;
				memcpy(ring->hdr.watches[watch].result, SvPV_nolen(result), len);
			}
			else if (!SvOK(result)) {
				ring->hdr.watches[watch].reslength = 0;
			}
			else {
				ring->hdr.watches[watch].reslength = len;
				memcpy(ring->hdr.watches[watch].result, SvPV_nolen(result), len);
			}
			ring->hdr.watches[watch].resready = 1;
			watch++;
			ST(0) = sv_2mortal(newSViv(((watch == STRACE_WATCH_CNT) ? 0 : watch)));
		}
		XSRETURN(1);
#line 881 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__get_watch_result); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__get_watch_result)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_get_watch_result(addr, watch)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	int	watch = (int)SvIV(ST(1));
#line 673 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        int len;
        char *zerobuttrue = "0E0";

		EXTEND(SP, 3);
		if ((watch < 0) || (watch > STRACE_WATCH_CNT) ||
			(!ring->hdr.watches[watch].resready)) {
			PUSHs(&PL_sv_undef);
			PUSHs(&PL_sv_undef);
			PUSHs(&PL_sv_undef);
		}
		else if (!ring->hdr.watches[watch].reslength) {
			ring->hdr.watches[watch].resready = 0;
			PUSHs(sv_2mortal(newSVpv(zerobuttrue, 3)));
			PUSHs(&PL_sv_undef);
			PUSHs(&PL_sv_undef);
		}
		else if (ring->hdr.watches[watch].reslength < 0) {
			len = -1 * ring->hdr.watches[watch].reslength;
			if (len > STRACE_WATCH_RESLEN)
				len = STRACE_WATCH_RESLEN;
			ring->hdr.watches[watch].resready = 0;
			PUSHs(sv_2mortal(newSViv(len)));
			PUSHs(&PL_sv_undef);
			PUSHs(sv_2mortal(newSVpv(ring->hdr.watches[watch].result, len)));
		}
		else {
			len = ring->hdr.watches[watch].reslength;
			if (len > STRACE_WATCH_RESLEN)
				len = STRACE_WATCH_RESLEN;
			PUSHs(sv_2mortal(newSViv(len)));
			PUSHs(sv_2mortal(newSVpv(ring->hdr.watches[watch].result, len)));
			PUSHs(&PL_sv_undef);
		}
#line 936 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__add_watch_expr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__add_watch_expr)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_add_watch_expr(addr, expr)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	SV *	expr = ST(1);
#line 727 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        int watch = 0;

		ST(0) = &PL_sv_undef;
		if (SvCUR(expr) <= STRACE_WATCH_EXPRLEN) {
			for (; (watch < STRACE_WATCH_CNT) && ring->hdr.watches[watch].inuse;
				watch++);

			if (watch < STRACE_WATCH_CNT) {
				memcpy(ring->hdr.watches[watch].expr, SvPV_nolen(expr), SvCUR(expr));
				ring->hdr.watches[watch].exprlength = SvCUR(expr);
				ring->hdr.watches[watch].inuse = 1;
				ST(0) = sv_2mortal(newSViv(watch));
			}
		}
		XSRETURN(1);
#line 973 "RingBuffer.c"
	PUTBACK;
	return;
    }
}


XS(XS_Devel__RingBuffer__Ring__free_watch_expr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__RingBuffer__Ring__free_watch_expr)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Devel::RingBuffer::Ring::_free_watch_expr(addr, watch)");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	addr = ST(0);
	int	watch = (int)SvIV(ST(1));
#line 754 "RingBuffer.xs"
        UV tmp = SvUV(addr);
        ring_bufptr_t ring = INT2PTR(ring_bufptr_t, tmp);
        ring->hdr.watches[watch].inuse = -2;
        ST(0) = &PL_sv_yes;
		XSRETURN(1);
#line 998 "RingBuffer.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Devel__RingBuffer); /* prototype to pass -Wmissing-prototypes */
XS(boot_Devel__RingBuffer)
{
    dXSARGS;
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Devel::RingBuffer::_get_ring_size", XS_Devel__RingBuffer__get_ring_size, file, "$$");
        newXSproto("Devel::RingBuffer::_get_total_size", XS_Devel__RingBuffer__get_total_size, file, "$$$$");
        newXSproto("Devel::RingBuffer::_get_rings_addr", XS_Devel__RingBuffer__get_rings_addr, file, "$$$");
        newXSproto("Devel::RingBuffer::_get_ring_addr", XS_Devel__RingBuffer__get_ring_addr, file, "$$$$");
        newXSproto("Devel::RingBuffer::_alloc_ring", XS_Devel__RingBuffer__alloc_ring, file, "$$");
        newXSproto("Devel::RingBuffer::_free_ring", XS_Devel__RingBuffer__free_ring, file, "$$$$");
        newXSproto("Devel::RingBuffer::_find_ring", XS_Devel__RingBuffer__find_ring, file, "$$$$$");
        newXSproto("Devel::RingBuffer::Ring::_init_ring", XS_Devel__RingBuffer__Ring__init_ring, file, "$$$$");
        newXSproto("Devel::RingBuffer::Ring::_get_slots_addr", XS_Devel__RingBuffer__Ring__get_slots_addr, file, "$");
        newXSproto("Devel::RingBuffer::Ring::_get_header", XS_Devel__RingBuffer__Ring__get_header, file, "$");
        newXS("Devel::RingBuffer::Ring::updateSlot", XS_Devel__RingBuffer__Ring_updateSlot, file);
        newXS("Devel::RingBuffer::Ring::nextSlot", XS_Devel__RingBuffer__Ring_nextSlot, file);
        newXS("Devel::RingBuffer::Ring::freeSlot", XS_Devel__RingBuffer__Ring_freeSlot, file);
        newXSproto("Devel::RingBuffer::Ring::_get_slot", XS_Devel__RingBuffer__Ring__get_slot, file, "$$");
        newXS("Devel::RingBuffer::Ring::getFlags", XS_Devel__RingBuffer__Ring_getFlags, file);
        newXSproto("Devel::RingBuffer::Ring::_get_trace", XS_Devel__RingBuffer__Ring__get_trace, file, "$");
        newXSproto("Devel::RingBuffer::Ring::_set_trace", XS_Devel__RingBuffer__Ring__set_trace, file, "$$");
        newXSproto("Devel::RingBuffer::Ring::_get_signal", XS_Devel__RingBuffer__Ring__get_signal, file, "$");
        newXSproto("Devel::RingBuffer::Ring::_set_signal", XS_Devel__RingBuffer__Ring__set_signal, file, "$$");
        newXSproto("Devel::RingBuffer::Ring::_post_cmd_msg", XS_Devel__RingBuffer__Ring__post_cmd_msg, file, "$$$$");
        newXSproto("Devel::RingBuffer::Ring::_check_for_cmd_msg", XS_Devel__RingBuffer__Ring__check_for_cmd_msg, file, "$$");
        newXSproto("Devel::RingBuffer::Ring::_get_watch_expr", XS_Devel__RingBuffer__Ring__get_watch_expr, file, "$$");
        newXSproto("Devel::RingBuffer::Ring::_set_watch_result", XS_Devel__RingBuffer__Ring__set_watch_result, file, "$$$$");
        newXSproto("Devel::RingBuffer::Ring::_get_watch_result", XS_Devel__RingBuffer__Ring__get_watch_result, file, "$$");
        newXSproto("Devel::RingBuffer::Ring::_add_watch_expr", XS_Devel__RingBuffer__Ring__add_watch_expr, file, "$$");
        newXSproto("Devel::RingBuffer::Ring::_free_watch_expr", XS_Devel__RingBuffer__Ring__free_watch_expr, file, "$$");
    XSRETURN_YES;
}

